#include "morfofun.hh"
#include "nominimorfo.hh"

using std::sprintf;

class NomiStruct
{
public:
	string mask;
	
	string nom[2], gen[2], akk[2], ess[2], par[2], tra[2],
	       ine[2], ela[2], ill[2],
	       ade[2], abl[2], all[2], abe[2],
	       kom[2], ins[2], person;
	string mul; // -sti
	string kompa[2], super[2];

	void set(const string &hdr, const vector<string> &tab)
	{
		if(!tab.size())return;
		if(hdr=="Mul") { mul = tab[0]; return; }
		if(hdr=="Person") { person = tab[0]; return; }
#include "nomihash.inc"
	}

	void clear()
	{
		mask.erase();
		for(unsigned a=0; a<2; ++a)
			nom[a].erase(), gen[a].erase(), akk[a].erase(),
			ess[a].erase(), par[a].erase(), tra[a].erase(),
			ine[a].erase(), ela[a].erase(), ill[a].erase(),
			ade[a].erase(), abl[a].erase(), all[a].erase(),
			kom[a].erase(), ins[a].erase(), abe[a].erase(),
			kompa[a].erase(), super[a].erase();
		mul.erase();
	}
	
	const string Replace(const string &word, const string &pat) const
	{
		return ::Replace(word, mask, pat);
	}
};

class PersStruct
{
public:
	string mask; // unused
	void clear() { } // unused
	
	string nom[12], gen[6], akk[6], ess[6], par[6], tra[6],
	       ine[6], ela[6], ill[6], ade[6], abl[6], all[6],
	       abe[6], kom[6], ins[6], kompa[6], super[6];

	void set(const string &hdr, const vector<string> &tab)
	{
		if(!tab.size())return;
		if(hdr=="Nom") { for(unsigned a=0; a<tab.size(); ++a)if(a<12)nom[a]=tab[a]; return; }
		if(hdr=="Gen") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)gen[a]=tab[a]; return; }
		if(hdr=="Akk") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)akk[a]=tab[a]; return; }
		if(hdr=="Ess") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)ess[a]=tab[a]; return; }
		if(hdr=="Par") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)par[a]=tab[a]; return; }
		if(hdr=="Tra") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)tra[a]=tab[a]; return; }
		if(hdr=="Ine") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)ine[a]=tab[a]; return; }
		if(hdr=="Ela") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)ela[a]=tab[a]; return; }
		if(hdr=="Ill") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)ill[a]=tab[a]; return; }
		if(hdr=="Ade") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)ade[a]=tab[a]; return; }
		if(hdr=="Abl") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)abl[a]=tab[a]; return; }
		if(hdr=="All") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)all[a]=tab[a]; return; }
		if(hdr=="Abe") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)abe[a]=tab[a]; return; }
		if(hdr=="Kom") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)kom[a]=tab[a]; return; }
		if(hdr=="Ins") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)ins[a]=tab[a]; return; }
		if(hdr=="Kompa") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)kompa[a]=tab[a]; return; }
		if(hdr=="Super") { for(unsigned a=0; a<tab.size(); ++a)if(a<6)super[a]=tab[a]; return; }
	}
	const string Replace(const string &word, const string &pat) const
	{
		unsigned a=0, b=word.size();
		bool yla = true;
		while(a < pat.size() && b > 0 && pat[a]=='-')--b, ++a;
		string s = word.substr(0, b);
		for(; b > 0; --b)if(word[b]=='a'||word[b]=='A'
		                  ||word[b]=='o'||word[b]=='O'
		                  ||word[b]=='u'||word[b]=='U'){yla=false;break;}
		for(; a < pat.size(); ++a)
			s += (pat[a]=='a' && yla) ? '' : pat[a];
		return s;
	}
};

static Struktit<NomiStruct> NomiStruktit("nomiruumiit.txt", "nomini");
static Struktit<NomiStruct> InfiStruktit("infiniruumiit.txt", "infinitiivi");
static Struktit<PersStruct> PersStruktit("persoonat.txt", "persoona");

const string Omistusliite(const NomiStruct &btr,const string &base,
                          const string &word, sijamuoto sija,
                          bool monikko, persoona pers)
{
	if(pers < YKS1 || pers > MON3)return word;	
	const PersStruct &str = PersStruktit.find(word);
	
	if(sija == NOMINATIIVI)
	{
		if(monikko)
			return str.Replace(word, str.nom[6 + pers]);
		return str.Replace(btr.Replace(base, btr.person), str.nom[0 + pers]);
	}
	if(sija == GENETIIVI)return str.Replace(word, str.gen[pers]);
	if(sija == AKKUSATIIVI)return str.Replace(word, str.akk[pers]);
	if(sija == ESSIIVI)return str.Replace(word, str.ess[pers]);
	if(sija == PARTITIIVI)return str.Replace(word, str.par[pers]);
	if(sija == TRANSLATIIVI)return str.Replace(word, str.tra[pers]);
	if(sija == INESSIIVI)return str.Replace(word, str.ine[pers]);
	if(sija == ELATIIVI)return str.Replace(word, str.ela[pers]);
	if(sija == ILLATIIVI)return str.Replace(word, str.ill[pers]);
	if(sija == ADESSIIVI)return str.Replace(word, str.ade[pers]);
	if(sija == ABLATIIVI)return str.Replace(word, str.abl[pers]);
	if(sija == ALLATIIVI)return str.Replace(word, str.all[pers]);
	if(sija == ABESSIIVI)return str.Replace(word, str.abe[pers]);
	if(sija == KOMITATIIVI)return str.Replace(word, str.kom[pers]);
	if(sija == INSTRUKTIIVI)return str.Replace(word, str.ins[pers]);
	if(sija == KOMPARATIIVI)return str.Replace(word, str.kompa[pers]);
	if(sija == SUPERLATIIVI)return str.Replace(word, str.super[pers]);
	if(sija == MULTIPLIKATIIVI)
	{
		if(pers != PASSIIVI)
			fprintf(stderr, "%s: Multiplikatiiviin ei voi liitt persoonaptett.\n", base.c_str());
		return word;
	}

	char Buf[128];
	sprintf(Buf, "?pers:sija=%u,word=", sija);
	return Buf + word;
}

const string InfiniTaivutus(unsigned infinum, const string &word, sijamuoto sija, bool monikko, persoona pers)
{
	const NomiStruct &str = InfiStruktit.find(word);
	
	if(infinum==1 && (monikko || (sija!=NOMINATIIVI && sija!=TRANSLATIIVI)))
	{
		sija = NOMINATIIVI;
		monikko = false;
		fprintf(stderr, "%s: I infinitiivist on vain yksikn nominatiivi ja yksikn translatiivi. Kytmme siis nominatiivia.\n", word.c_str());
	}
	else if(infinum==2 && (sija!=INESSIIVI && sija!=INSTRUKTIIVI))
	{
		sija = INESSIIVI;
		fprintf(stderr, "%s: II infinitiivist on vain yksikn inessiivi ja yksikn instruktiivi. Kytmme siis inessiivi.\n", word.c_str());
	}
	else if(infinum==3 && (pers==PASSIIVI) && (monikko || sija!=INSTRUKTIIVI))
	{
		sija = INSTRUKTIIVI; monikko = false;
		fprintf(stderr, "%s: III infinitiivist ei ole passiivissa kuin yksikn instruktiivi. Kytmme siis instruktiivia.\n", word.c_str());
	}
	else if(infinum==5 && (monikko || sija!=ADESSIIVI))
	{
		sija = ADESSIIVI;
		monikko = false;
		fprintf(stderr, "%s: V infinitiivist on vain yksikn adessiivi. Kytmme siis sit.\n", word.c_str());
	}
	if(infinum==1 && sija==NOMINATIIVI && pers != PASSIIVI)
	{
		pers = PASSIIVI;
		fprintf(stderr, "%s: I infinitiivin nominatiivilla ei ole omistusliitteellist versiota. Otetaan moinen siis pois.\n", word.c_str());
	}
	if(sija==TRANSLATIIVI && pers == PASSIIVI)
	{
		pers = YKS1;
		fprintf(stderr, "%s: Infinitiivien translatiivilla ei ole omistusliitteetnt versiota. Kytmme siis yksikn ensimmist persoonaa.\n", word.c_str());
	}
	if(sija == INSTRUKTIIVI && pers != PASSIIVI)
	{
		fprintf(stderr, "%s: Instruktiivi ei esiinny yhdess omistusliitteen kanssa. Otetaan moinen siis pois.\n", word.c_str());
		pers = PASSIIVI;
	}
	
	switch(sija)
	{
		case NOMINATIIVI: return Omistusliite(str,word, str.Replace(word, str.nom[monikko?1:0]), sija, monikko, pers);
		case GENETIIVI: return Omistusliite(str,word, str.Replace(word, str.gen[monikko?1:0]), sija, monikko, pers);
		case AKKUSATIIVI: return Omistusliite(str,word, str.Replace(word, str.akk[monikko?1:0]), sija, monikko, pers);
		case ESSIIVI: return Omistusliite(str,word, str.Replace(word, str.ess[monikko?1:0]), sija, monikko, pers);
		case PARTITIIVI: return Omistusliite(str,word, str.Replace(word, str.par[monikko?1:0]), sija, monikko, pers);
		case TRANSLATIIVI: return Omistusliite(str,word, str.Replace(word, str.tra[monikko?1:0]), sija, monikko, pers);
		case INESSIIVI: return Omistusliite(str,word, str.Replace(word, str.ine[monikko?1:0]), sija, monikko, pers);
		case ELATIIVI: return Omistusliite(str,word, str.Replace(word, str.ela[monikko?1:0]), sija, monikko, pers);
		case ILLATIIVI: return Omistusliite(str,word, str.Replace(word, str.ill[monikko?1:0]), sija, monikko, pers);
		case ADESSIIVI: return Omistusliite(str,word, str.Replace(word, str.ade[monikko?1:0]), sija, monikko, pers);
		case ABLATIIVI: return Omistusliite(str,word, str.Replace(word, str.abl[monikko?1:0]), sija, monikko, pers);
		case ALLATIIVI: return Omistusliite(str,word, str.Replace(word, str.all[monikko?1:0]), sija, monikko, pers);
		case ABESSIIVI: return Omistusliite(str,word, str.Replace(word, str.abe[monikko?1:0]), sija, monikko, pers);
		case KOMITATIIVI: return Omistusliite(str,word, str.Replace(word, str.kom[monikko?1:0]), sija, monikko, pers);
		case INSTRUKTIIVI: return Omistusliite(str,word, str.Replace(word, str.ins[monikko?1:0]), sija, monikko, pers);
		case KOMPARATIIVI: return Omistusliite(str,word, str.Replace(word, str.kompa[monikko?1:0]), sija, monikko, pers);
		case SUPERLATIIVI: return Omistusliite(str,word, str.Replace(word, str.super[monikko?1:0]), sija, monikko, pers);
	}
	char Buf[128];
	sprintf(Buf, "?%uinf:sija=%u,word=", infinum, sija);
	return Buf + word;
}

const string NominiTaivutus(const string &word, sijamuoto sija, bool monikko, persoona pers)
{
	const NomiStruct &str = NomiStruktit.find(word);
	
	if(sija == INSTRUKTIIVI && pers != PASSIIVI)
	{
		fprintf(stderr, "%s: Instruktiivi ei esiinny yhdess omistusliitteen kanssa. Otetaan moinen siis pois.\n", word.c_str());
		pers = PASSIIVI;
	}
	
	switch(sija)
	{
		case NOMINATIIVI: return Omistusliite(str,word, str.Replace(word, str.nom[monikko?1:0]), sija, monikko, pers);
		case GENETIIVI: return Omistusliite(str,word, str.Replace(word, str.gen[monikko?1:0]), sija, monikko, pers);
		case AKKUSATIIVI: return Omistusliite(str,word, str.Replace(word, str.akk[monikko?1:0]), sija, monikko, pers);
		case ESSIIVI: return Omistusliite(str,word, str.Replace(word, str.ess[monikko?1:0]), sija, monikko, pers);
		case PARTITIIVI: return Omistusliite(str,word, str.Replace(word, str.par[monikko?1:0]), sija, monikko, pers);
		case TRANSLATIIVI: return Omistusliite(str,word, str.Replace(word, str.tra[monikko?1:0]), sija, monikko, pers);
		case INESSIIVI: return Omistusliite(str,word, str.Replace(word, str.ine[monikko?1:0]), sija, monikko, pers);
		case ELATIIVI: return Omistusliite(str,word, str.Replace(word, str.ela[monikko?1:0]), sija, monikko, pers);
		case ILLATIIVI: return Omistusliite(str,word, str.Replace(word, str.ill[monikko?1:0]), sija, monikko, pers);
		case ADESSIIVI: return Omistusliite(str,word, str.Replace(word, str.ade[monikko?1:0]), sija, monikko, pers);
		case ABLATIIVI: return Omistusliite(str,word, str.Replace(word, str.abl[monikko?1:0]), sija, monikko, pers);
		case ALLATIIVI: return Omistusliite(str,word, str.Replace(word, str.all[monikko?1:0]), sija, monikko, pers);
		case ABESSIIVI: return Omistusliite(str,word, str.Replace(word, str.abe[monikko?1:0]), sija, monikko, pers);
		case KOMITATIIVI: return Omistusliite(str,word, str.Replace(word, str.kom[monikko?1:0]), sija, monikko, pers);
		case INSTRUKTIIVI: return Omistusliite(str,word, str.Replace(word, str.ins[monikko?1:0]), sija, monikko, pers);
		case KOMPARATIIVI: return Omistusliite(str,word, str.Replace(word, str.kompa[monikko?1:0]), sija, monikko, pers);
		case SUPERLATIIVI: return Omistusliite(str,word, str.Replace(word, str.super[monikko?1:0]), sija, monikko, pers);
		case MULTIPLIKATIIVI: return Omistusliite(str,word, str.Replace(word, str.mul), sija, monikko, pers);
	}
	char Buf[128];
	sprintf(Buf, "?nom:sija=%u,word=\n", sija);
	return Buf + word;
}
